package com.four.projects.urnasocial.server.model;

import javax.persistence.Entity;
import java.io.Serializable;
import javax.persistence.Id;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Column;
import javax.persistence.Version;
import java.lang.Override;

@Entity
public class Candidato implements Serializable
{

   @Id
   @GeneratedValue(strategy = GenerationType.AUTO)
   @Column(name = "id", updatable = false, nullable = false)
   private Long id = null;
   @Version
   @Column(name = "version")
   private int version = 0;

   @Column
   private String SiglaUf;

   @Column
   private String SiglaUe;

   @Column
   private String DescricaoUe;

   @Column
   private String CodigoCargo;

   @Column
   private String DescricaoCargo;

   @Column
   private String NomeCandidato;

   @Column
   private String SequencialCandidato;

   @Column
   private String NumeroCandidato;

   @Column
   private String NomeUrnaCandidato;

   @Column
   private String CodSituacaoCandidatura;

   @Column
   private String DesSituacaoCandidatura;

   @Column
   private String NumeroPartido;

   @Column
   private String SiglaPartido;

   @Column
   private String NomePartido;

   public Long getId()
   {
      return this.id;
   }

   public void setId(final Long id)
   {
      this.id = id;
   }

   public int getVersion()
   {
      return this.version;
   }

   public void setVersion(final int version)
   {
      this.version = version;
   }

   @Override
   public boolean equals(Object that)
   {
      if (this == that)
      {
         return true;
      }
      if (that == null)
      {
         return false;
      }
      if (getClass() != that.getClass())
      {
         return false;
      }
      if (id != null)
      {
         return id.equals(((Candidato) that).id);
      }
      return super.equals(that);
   }

   @Override
   public int hashCode()
   {
      if (id != null)
      {
         return id.hashCode();
      }
      return super.hashCode();
   }

   public String getSiglaUf()
   {
      return this.SiglaUf;
   }

   public void setSiglaUf(final String SiglaUf)
   {
      this.SiglaUf = SiglaUf;
   }

   public String getSiglaUe()
   {
      return this.SiglaUe;
   }

   public void setSiglaUe(final String SiglaUe)
   {
      this.SiglaUe = SiglaUe;
   }

   public String getDescricaoUe()
   {
      return this.DescricaoUe;
   }

   public void setDescricaoUe(final String DescricaoUe)
   {
      this.DescricaoUe = DescricaoUe;
   }

   public String getCodigoCargo()
   {
      return this.CodigoCargo;
   }

   public void setCodigoCargo(final String CodigoCargo)
   {
      this.CodigoCargo = CodigoCargo;
   }

   public String getDescricaoCargo()
   {
      return this.DescricaoCargo;
   }

   public void setDescricaoCargo(final String DescricaoCargo)
   {
      this.DescricaoCargo = DescricaoCargo;
   }

   public String getNomeCandidato()
   {
      return this.NomeCandidato;
   }

   public void setNomeCandidato(final String NomeCandidato)
   {
      this.NomeCandidato = NomeCandidato;
   }

   public String getSequencialCandidato()
   {
      return this.SequencialCandidato;
   }

   public void setSequencialCandidato(final String SequencialCandidato)
   {
      this.SequencialCandidato = SequencialCandidato;
   }

   public String getNumeroCandidato()
   {
      return this.NumeroCandidato;
   }

   public void setNumeroCandidato(final String NumeroCandidato)
   {
      this.NumeroCandidato = NumeroCandidato;
   }

   public String getNomeUrnaCandidato()
   {
      return this.NomeUrnaCandidato;
   }

   public void setNomeUrnaCandidato(final String NomeUrnaCandidato)
   {
      this.NomeUrnaCandidato = NomeUrnaCandidato;
   }

   public String getCodSituacaoCandidatura()
   {
      return this.CodSituacaoCandidatura;
   }

   public void setCodSituacaoCandidatura(final String CodSituacaoCandidatura)
   {
      this.CodSituacaoCandidatura = CodSituacaoCandidatura;
   }

   public String getDesSituacaoCandidatura()
   {
      return this.DesSituacaoCandidatura;
   }

   public void setDesSituacaoCandidatura(final String DesSituacaoCandidatura)
   {
      this.DesSituacaoCandidatura = DesSituacaoCandidatura;
   }

   public String getNumeroPartido()
   {
      return this.NumeroPartido;
   }

   public void setNumeroPartido(final String NumeroPartido)
   {
      this.NumeroPartido = NumeroPartido;
   }

   public String getSiglaPartido()
   {
      return this.SiglaPartido;
   }

   public void setSiglaPartido(final String SiglaPartido)
   {
      this.SiglaPartido = SiglaPartido;
   }

   public String getNomePartido()
   {
      return this.NomePartido;
   }

   public void setNomePartido(final String NomePartido)
   {
      this.NomePartido = NomePartido;
   }

   @Override
   public String toString()
   {
      String result = getClass().getSimpleName() + " ";
      if (SiglaUf != null && !SiglaUf.trim().isEmpty())
         result += "SiglaUf: " + SiglaUf;
      if (SiglaUe != null && !SiglaUe.trim().isEmpty())
         result += ", SiglaUe: " + SiglaUe;
      if (DescricaoUe != null && !DescricaoUe.trim().isEmpty())
         result += ", DescricaoUe: " + DescricaoUe;
      if (CodigoCargo != null && !CodigoCargo.trim().isEmpty())
         result += ", CodigoCargo: " + CodigoCargo;
      if (DescricaoCargo != null && !DescricaoCargo.trim().isEmpty())
         result += ", DescricaoCargo: " + DescricaoCargo;
      if (NomeCandidato != null && !NomeCandidato.trim().isEmpty())
         result += ", NomeCandidato: " + NomeCandidato;
      if (SequencialCandidato != null && !SequencialCandidato.trim().isEmpty())
         result += ", SequencialCandidato: " + SequencialCandidato;
      if (NumeroCandidato != null && !NumeroCandidato.trim().isEmpty())
         result += ", NumeroCandidato: " + NumeroCandidato;
      if (NomeUrnaCandidato != null && !NomeUrnaCandidato.trim().isEmpty())
         result += ", NomeUrnaCandidato: " + NomeUrnaCandidato;
      if (CodSituacaoCandidatura != null
            && !CodSituacaoCandidatura.trim().isEmpty())
         result += ", CodSituacaoCandidatura: " + CodSituacaoCandidatura;
      if (DesSituacaoCandidatura != null
            && !DesSituacaoCandidatura.trim().isEmpty())
         result += ", DesSituacaoCandidatura: " + DesSituacaoCandidatura;
      if (NumeroPartido != null && !NumeroPartido.trim().isEmpty())
         result += ", NumeroPartido: " + NumeroPartido;
      if (SiglaPartido != null && !SiglaPartido.trim().isEmpty())
         result += ", SiglaPartido: " + SiglaPartido;
      if (NomePartido != null && !NomePartido.trim().isEmpty())
         result += ", NomePartido: " + NomePartido;
      return result;
   }
}